/*  	x86/init_exec.c  		Rick Hohensee 19990904
x86 gcc/gas libc-less execve-->command argc/argv/environ  passer. 
compare to crt0.S
In particular, we don't call libc_init

Apparently Linux execve gives a new process a stack in the form of

sp   sp+1...			<--- stack pointer
argc,argvargvargv...,environ 	<--- data structure

argc is a number. argv is an array of pointers. argc is in effect the
index of that array. environ is apparently one pointer.  This code names
these critters and copies them to RAM so C can use them without buying
into the whole libc thing. This is a wrapper that must surround the top C
function.  (The libc main() and other services are achieved with a similar
wrapper.)

Stuff I have no clue about in e.g. libc's crt0.S is left out, like the
stuff for padding the caller's stack frame. I just hope they were kidding.
And IBCS stuff. "It works here." 

references:
	GNU .info on as, gcc & libc. 
	The ELF spec.   www.muppetlabs.com   e.g. 
	libc crt0.S. 
	asm/unistd.h 
*/

asm ("
	.text			# unix object-code files have segments. 
				# 	.text is where the code is.
				# 	These guys just have a knack for names.
	.align  16,0x90		# from crt0.S, 0x90 NOOP on Intel, no?
	.globl _start		# extraneous?
	.type _start,@function	
_start:				# GNU ld looks for _start. This is the address
				#   that goes in the ELF header, and the CPU 
				# begin execution of this program...

	popl %ecx		# get argc off the stack
	movl %ecx,argc		# save it to RAM as a  global symbol

	movl %esp,%ebx 		# snag argv, 
	movl %ebx,argv  	# save also

	movl %esp,%eax 		# stack item to accum
	movl %eax,curious	#  this one is me. I'm curious

	andl $0xfffffff8,%esp	# mask low 3 bits off stack pointer, esp not 
				# 	used again though. i.e. lose this.
				# 	Or this keeps the stack in sync. 

	movl %ecx,%edx		# argc to edx
	addl %edx,%edx		# edx is now  argc * 2
	addl %edx,%edx		# edx is now  argc * 4
	addl %edx,%eax		# (argc*4) + eax
	addl $4,%eax		# (argc*4) + 4 + eax
				# 
	movl %eax, environ	# 

	.globl argc
	.globl argv

	call main		#  call what we are the wrapper of

	movl argv, %ebx		# return value. should be a stack snag?
	movl $1, %eax		# the exit syscall
	int $0x80		#      ditto


	.align  16,0x90	
	.size	_start,.-_start
	.globl environ
	.data
	.type environ,@object
	.align 4, 0
environ:
	.long 0
	.size environ,4
	.weak environ
	.type  argv,@object
	.align 4, 0
argc:	.long
	.long 0

argv:	.long 
	.long 0 
curious: 
	.long 
	.long 0
	

");

