 /*   20000121  Rick Hohensee  bootsector.S   GNU assembler syntax

We are 512 bytes loaded in RAM at 0x7c00 by the BIOS. 
Our brain is 80386 real address mode. We're in segment 0.

      ..................................................................
                          14.1 Physical Address Formation

   The 80386 provides a one Mbyte + 64 Kbyte memory space for an 8086 program.
   Segment relocation is performed as in the 8086: the 16-bit value in a segment
   selector is shifted left by four bits to form the base address of a segment. The
   effective address is extended with four high order zeros and added to the base
   to form a linear address as Figure 14-1 illustrates. (The linear address is
   equivalent to the physical address, because paging is not used in real-address
   mode.) Unlike the 8086, the resulting linear address may have up to 21
   significant bits. There is a possibility of a carry when the base address is
   added to the effective address. On the 8086, the carried bit is truncated,
   whereas on the 80386 the carried bit is stored in bit position 20 of the linear
   address.

   Unlike the 8086 and 80286, 32-bit effective addresses can be generated (via the
   address-size prefix); however, the value of a 32-bit address may not exceed
   65535 without causing an exception. For full compatibility with 80286
   real-address mode, pseudo-protection faults (interrupt 12 or 13 with no error
   code) occur if an effective address is generated outside the range 0 through
   65535.

	.................................................................



Certain IO addresses are known. We have a 16 bit BIOS.  
Howdy y'all!


/help/HARDWARE.TXT
floppy
	*PS/2* FDC Diskette Status Register A at 3F0h 
	*PS/2* FDC Diskette Status Register B at 3F0h 
******	FDC Digital Output Register at 3F2h**************** motor control
	FDC Main Status Register at 3F4h 
	FDC Command Status Register 0 at 3F5h
*/




.code16			/* 
		GNU ../binutils<ver>/gas/doc/c-i386.html
			*/
.text			/* .text is a code segment. Go figure.		*/
.globl	_start		/*   GNU ld looks for _start by default		*/

/* sequence......


	Turn into a 386
	throw up some junk on the screen
	wait for BIOS to relinquish the FDC	
	Turn on floppy motor. It's still spinning, so no delay this way.

	Load ourself and stage2. (and stage3 ?)
		We can overlay a bigger us over ourself if we don't have any
		state in memory. We don't, at this point.
	stash system info
		(Where's our stack?)
	branch to stage2, "main" 
*/



_start:					/* default GNU ld starting point */





        mov     %eax, %cr0
        mov     $0x1, %eax
        mov     %eax, %cr0
        jmp     IA32

IA32:

.code32

	cli				/* this keeps the floppy motor on.
						Curious. */




/* cLIeNUX: */
        mov     $0x03 , %ah
        xor     %bh , %bh
        int     $0x10
        mov     $0x0100 , %cx			/* display this code and sector 2 */
        mov     $0x07 , %bx       			#
        mov     $0x7c00 , %bp				#
        mov     $0x1301 , %ax          			#
        int     $0x10					#


	hlt






splash:
	.byte 10,13
	.byte 10,13
	.byte 10,13
	.ascii "cLIeNUX Bootsector."
	.byte 10,13

	.byte   0xb0
	.byte   0xb0
	.byte   0xb0
	.byte   0xb0
	.byte   0xb0

.org 510
boot_flag:
	.word 0xAA55




stage_2:

/* no nothing down here. This will be stage_2 courtesy of cat. */
